//
//  sine.c
//  sine - demonstration of sine wave generation
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

int main(int argc, const char * argv[])
{
    if ((argc < 3 )||(argc > 3 )) {
        printf("USAGE:\n\tsine <cycles> <samples_per_cycle>\n");
        printf("\texample:\n\tsine 20 500\n");
        return 0;    
    }
    
    int cycles = atoi(argv[1]);
    int spc    = atoi(argv[2]);

    float step   = 2.0*M_PI/(float)spc;  //step in radians
    size_t length= (size_t)cycles*spc;   //length in samples
    float a      = 0.6;
    
    for(size_t i = 0; i < length; i++)
        printf("%f\n",a*sinf(i*step));
    
    return 0;
}
