//
//  sinef.c
//  sinef - generate sine wave and save it to binary file
//
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <unistd.h>

int main(int argc, const char * argv[])
{
    char name[256];
    FILE *sfPtr;
    if ((argc < 4 )||(argc > 4 )) {
        printf("USAGE:\n\tsinef <cycles> <samples_per_cycle> <dest_file>\n");
        printf("\texample:\n\tsinef 20 500 testfile\n");
        return 0;
    }
    float cycles = atof(argv[1]);
    float spc    = atof(argv[2]);
    strcpy(name,argv[3]);
    
    float step   = 2.0*M_PI/spc; //step in radians
    size_t length= cycles*spc;   //length in samples
    
    if( access( name, F_OK ) != -1 ){
        printf("File \"%s\" exisits!\n", name);
        return 1;
    }
    if((sfPtr    = fopen(name, "wb"))== NULL)return 1;

    float a      = 0.6;          //amplitude    
    float* buf   = (float*)calloc(length, sizeof(float));
    
    for(size_t i = 0; i < length; i++){
        buf[i]   = a*sinf(i*step);
    }
    
    fwrite(buf,sizeof(float),length, sfPtr);
    
    fclose(sfPtr);
        
    return 0;
}

