//
//  siner.c
//  sine - demonstration of sine wave production with
//         rate, duration and frequency
//  Created by Stanko Juzbasic on 2/12/15.
//

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main(int argc, const char * argv[])
{
    if ((argc < 4 )||(argc > 4 )) {
        printf("USAGE:\n\tsiner <dur> <freq> <srate>\n");
        printf("\texample:\n\tsiner 5 440 44100\n");
        return 0;    
    }
    
    float dur  = (float)atof(argv[1]);
    float freq = (float)atof(argv[2]);
    float R    = (float)atof(argv[3]);

    float om   = 2.0*M_PI*freq/R;     //circular frequency
    size_t length= (size_t)(dur*R);   //length in samples
    float a      = 0.6;
    
    for(size_t i = 0; i < length; i++)
        printf("%f\n",a*sinf(i*om));
    
    return 0;
}
